import System.Environment (getArgs)
import System.Posix.User (getLoginName)
import LDAP

attrs = ["cn;lang-en","mail"]

getUser = do
  args <- getArgs
  case args of
    []     -> getLoginName
    [user] -> return user
    _      -> error "Zero or one argument requested"

main = do
  user <- getUser
  ldap <- ldapInitialize "ldaps://directory.iif.hu"
  ldapSimpleBind ldap "" "" -- anonymous bind
  res <- ldapSearch ldap (Just "o=niifi,o=niif,c=hu") LdapScopeSubtree
                    (Just $ "(&(objectClass=posixAccount)(uid=" ++ user ++ "))") (LDAPAttrList attrs) False
  case res of
    []                -> error $ "No single hit for " ++ user
    [LDAPEntry dn as] -> putStrLn $
      case map (flip lookup as) attrs of
        [Just [name], Just [email]] -> name ++ " <" ++ email ++ ">"
        [Nothing    , Just [email]] -> email
        [Just _     , _           ] -> error $ "Ambiguous name for " ++ dn
        [Nothing    , _           ] -> error $        "No name for " ++ dn
        [_          , Just _      ] -> error $ "Ambiguous email address for " ++ dn
        [_          , Nothing     ] -> error $        "No email address for " ++ dn
